SystemOrganization addCategory: #iAddress!

WAComponent subclass: #ContactListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!ContactListView methodsFor: 'rendering' stamp: 'Evelyn 9/15/2012 16:22'!
addContact
    | name emailAddress |
    name := self request: 'Name'.
    emailAddress := self request: 'Email address'.
    Contact addContact: (Contact name: name emailAddress: emailAddress)! !

!ContactListView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:54'!
editContact: aContact
    | view |
    view := ContactView new.
    view contact: aContact.
    self show: view onAnswer: [ :answer |
        self inform: 'Thanks for editing  ' , aContact name ]! !

!ContactListView methodsFor: 'rendering' stamp: 'Evelyn 9/15/2012 16:28'!
removeContact: aContact
    (self confirm: 'Are you sure that you want to remove this contact?')
        ifTrue: [ Contact removeContact: aContact ]! !

!ContactListView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 16:55'!
renderContact: aContact on: html
	html text: aContact name.
	html space.
	html anchor
		url: 'mailto:' , aContact emailAddress;
		with: aContact emailAddress.
	html text: ' ('.
	html anchor
		callback: [ self editContact: aContact ];
		with: 'edit'.	" <-- added "
	html space.
	html anchor
		callback: [ self removeContact: aContact ];
		with: 'remove'.
	html text: ')'! !

!ContactListView methodsFor: 'rendering' stamp: 'Evelyn 9/15/2012 16:18'!
renderContentOn: html
    html anchor
        callback: [ self addContact ];
        with: 'Add contact'.
    html unorderedList: [
        Contact contacts do: [ :contact |
            html listItem: [ self renderContact: contact on: html ] ] ]! !

ContactListView subclass: #PluggableContactListView
	instanceVariableNames: 'contactViewers editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:38'!
addContact: aContact
    Contact addContact: aContact.
    self addContactViewerFor: aContact! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:35'!
addContactViewerFor: aContact
    contactViewers
        at: aContact
        put: (ReadOnlyOneLinerContactView new
            contact: aContact;
            parent: self; " <-- added "
            yourself)! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:37'!
askAndCreateContact
     | name emailAddress |
     name := self request: 'Name'.
     emailAddress := self request: 'Email address'.
     self addContact: (Contact name: name emailAddress: emailAddress)
! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:37'!
children
    ^ contactViewers values! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:33'!
contacts
    ^ Contact contacts! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:37'!
editor: anEditor
    editor := anEditor! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:34'!
initialize
    super initialize.
    editor := ContactView new.
    contactViewers := IdentityDictionary new.
    self contacts do: [ :each | self addContactViewerFor: each ]! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:38'!
removeContact: aContact
    contactViewers removeKey: aContact.
    Contact removeContact: aContact! !

!PluggableContactListView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:37'!
renderContentOn: html
    contactViewers values
        do: [ :each | html render: each. html break ]! !

WAComponent subclass: #ContactView
	instanceVariableNames: 'contact'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:23'!
cancel
    self answer: false! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/15/2012 16:40'!
contact
    ^ contact ifNil: [ contact := Contact contacts first ]! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/15/2012 16:40'!
contact: aContact
    contact := aContact! !

!ContactView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 15:56'!
initialize
    super initialize.
    self addDecoration: (WAFormDecoration new buttons: #(cancel save)).
    self addDecoration: (WAWindowDecoration new title: 'Zork Contacts')! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:39'!
renderContentOn: html
    html form: [
        self renderNameOn: html.
        self renderEmailOn: html.
        self renderGenderOn: html.
        self renderSendUpdatesOn: html.
        self renderDateOn: html.
        self renderSaveOn: html ]! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:42'!
renderDateOn: html
	html text: 'Birthday: '.
	html dateInput
		callback: [ :value | self contact birthdate: value ];
		with: self contact birthdate.
	html break.! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:42'!
renderEmailOn: html
	html text: 'Email address:'.
	html textInput on: #emailAddress of: self contact.
	html break.! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:42'!
renderGenderOn: html
	| group |
	html text: 'Gender: '.
	group := html radioGroup.
	group radioButton
		selected: self contact isMale;
		callback: [ self contact beMale ].
	html text: 'Male'.
	group radioButton
		selected: self contact isFemale;
		callback: [ self contact beFemale ].
	html text: 'Female'.
	html break.! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:37'!
renderNameOn: html
	html text: 'Name:'.
	html textInput on: #name of: self contact.
	html break.! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:45'!
renderSaveOn: html
        html submitButton on: #cancel of: self. " <-- added "
        html submitButton on: #save of: self! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:43'!
renderSendUpdatesOn: html
	html text: 'Send email updates: '.
	html checkbox
		value: self contact requestsEmailUpdates;
		callback: [ :value | self contact requestsEmailUpdates: value ].
	html break.! !

!ContactView methodsFor: 'rendering' stamp: 'Evelyn 9/17/2012 10:22'!
save
    self answer: true! !

ContactView subclass: #ReadOnlyOneLinerContactView
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!ReadOnlyOneLinerContactView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:31'!
parent: aParent
    parent := aParent! !

!ReadOnlyOneLinerContactView methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:32'!
renderContentOn: html
        html anchor
            callback: [parent editContact: self contact];
            with: self contact name.
        html space.
        html text: self contact emailAddress.
        html space.
        html anchor
            callback: [parent removeContact: self contact];
            with: '--'.
        html break.! !

WAComponent subclass: #IAddress
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:06'!
addContact: aContact
    Contact addContact: aContact! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:06'!
askAndCreateContact
    | name emailAddress |
    name := self request: 'Name'.
    emailAddress := self request: 'Email address'.
    self addContact: (Contact name: name emailAddress: emailAddress)! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:05'!
children
    ^ Array with: editor! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:04'!
contacts
    ^ Contact contacts! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:06'!
editContact: aContact
    editor contact: aContact! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 15:54'!
initialize
    super initialize.
    editor := ContactView new.
    editor contact: self contacts first.
    editor addMessage: 'Editing...'.  " <-- added "
    editor onAnswer: [ :answer | self inform: 'Saved', answer printString ]! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 17:02'!
pruebaEvelyn: html 
    	html text: 'Aqui ira mi estrellita:'.
	html image
      altText: 'Seaside';
      url: (JQUiAllFunctionalTestsLibrary urlOf: #seastarPng);
      script: (html jQuery new draggable opacity: 0.75).
	html break.! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:06'!
removeContact: aContact
    (self confirm: 'Are you sure that you want to remove this contact?')
        ifTrue: [ Contact removeContact: aContact ]! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:08'!
renderBarOn: html
   html anchor
       callback: [ self askAndCreateContact ]; 
       with: 'Add contact'! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:08'!
renderContact: aContact on: html
    html tableData: [
        html anchor
            callback: [ self editContact: aContact ];
            with: aContact name].
    html tableData: aContact emailAddress.
    html tableData: [
        html anchor
            callback: [ self removeContact: aContact ];
            with: '--' ]! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 17:01'!
renderContentOn: html
	html
		form: [ 
			self renderTitleOn: html.
			self renderBarOn: html.
			html
				table: [ 
					html
						tableRow: [ 
							html tableHeading: 'Name'.
							html tableHeading: 'Address' ].
					self renderDatabaseRowsOn: html ].
			html horizontalRule.
			self pruebaEvelyn:  html.
			html horizontalRule.
			html render: editor ]! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:08'!
renderDatabaseRowsOn: html
    self contacts do: [ :contact |
        html tableRow: [ self renderContact: contact on: html ] ]! !

!IAddress methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:07'!
renderTitleOn: html
    html heading level: 2; with: 'iAddress'! !

IAddress subclass: #IAddressTwoComponents
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!IAddressTwoComponents methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:40'!
children
    ^ super children , (Array with: list)! !

!IAddressTwoComponents methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:40'!
initialize
    super initialize.
    list := PluggableContactListView new.
    list editor: editor  " <-- added "! !

!IAddressTwoComponents methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:40'!
renderBarOn: html
    html anchor
        callback: [ list askAndCreateContact ]; 
        with: 'Add contact'! !

!IAddressTwoComponents methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/17/2012 11:40'!
renderContentOn: html
    html form: [
        self renderTitleOn: html.
        self renderBarOn: html.
        html break.
        html render: list.
        html horizontalRule.
        html render: editor ]! !

TestCase subclass: #TestCaseContactTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!TestCaseContactTest methodsFor: 'testing' stamp: 'Evelyn 10/20/2012 10:27'!
testAnnouncement
	| collection oldCollection suite unitTest |
	unitTest := ClassFactoryForTestCaseTest.
	collection := OrderedCollection new.
	unitTest resetAnnouncer.
	
	self deny: (unitTest shouldAnnounce).
	self deny: (unitTest new shouldAnnounce).
		
	unitTest announcer on: TestCaseAnnouncement do: [:ann | collection add: ann ].

	self assert: (unitTest shouldAnnounce).
	self assert: (unitTest new shouldAnnounce).

	"We run SUnitTest"
	suite := unitTest buildSuite.
	suite run.

	self assert: (collection size = (suite tests size * 2)).
	self assert: (collection select: [:c | c isKindOf: TestCaseStarted]) size = (collection size / 2).
	self assert: (collection select: [:c | c isKindOf: TestCaseEnded]) size =( collection size / 2).
	self assert: (collection allSatisfy: #hasPassed).
	self deny: (collection anySatisfy: #hasFailures).
	
	oldCollection := collection copy.
	unitTest resetAnnouncer.
	unitTest debug: #testClassCreationInDifferentCategories.
	self assert: (collection = oldCollection)! !

!TestCaseContactTest methodsFor: 'testing' stamp: 'Evelyn 10/20/2012 10:29'!
testIsUnitTest
	self assert: TestCase isUnitTest! !

JQUiFunctionalTest subclass: #JQTabsFunctionalTest
	instanceVariableNames: 'selectedTab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!JQTabsFunctionalTest methodsFor: 'initialization' stamp: 'lr 7/14/2010 13:49'!
initialize
	super initialize.
	selectedTab := 0! !

!JQTabsFunctionalTest methodsFor: 'rendering' stamp: 'lr 7/14/2010 13:55'!
renderContentOn: html
	html div
		script: (html jQuery new tabs
			selected: selectedTab;
			onSelect: (html jQuery ajax 
				callbackTabs: [ :event | selectedTab:= event at: #index ]));
		with: [
			html unorderedList: [
				self berries keysAndValuesDo: [ :name :description |
					html listItem: [
						html anchor
							url: (html jQuery ajax
								html: [ :h | h text: description ];
								fullUrl);
							with: name ] ] ] ]
! !

!JQTabsFunctionalTest methodsFor: 'accessing' stamp: 'lr 10/29/2008 08:32'!
selectors
	^ #(renderContentOn:)! !

!JQTabsFunctionalTest methodsFor: 'accessing' stamp: 'lr 12/17/2008 09:37'!
title
	^ 'Tabs Widget'! !

!JQTabsFunctionalTest methodsFor: 'accessing' stamp: 'lr 1/28/2010 18:11'!
url
	^ 'http://docs.jquery.com/UI/Tabs'! !

Object subclass: #Contact
	instanceVariableNames: 'birthdate name emailAddress gender requestsEmailUpdates'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'iAddress'!

!Contact class methodsFor: 'initialization' stamp: 'Evelyn 9/15/2012 16:07'!
addContact: aContact
    self contacts add: aContact! !

!Contact class methodsFor: 'initialization' stamp: 'Evelyn 9/15/2012 16:07'!
contacts
    "Answers an OrderedCollection of the contact information instances."

    Database isNil ifTrue: [ self createSampleDatabase ].
    ^ Database! !

!Contact class methodsFor: 'initialization' stamp: 'Evelyn 10/21/2012 10:03'!
createSampleDatabase
    Database := OrderedCollection new
        add: (self name: 'Evelyn Perez Cervantes' emailAddress: 'epcervantes7@gmail.com');
        add: (self name: 'Nataly Perez Cervantes' emailAddress: 'natalypc2@gmail.com');
        add: (self name: 'Sidney Perez Cervantes' emailAddress: 'sidneypc27@gmail.com');
        yourself! !

!Contact class methodsFor: 'initialization' stamp: 'Evelyn 9/15/2012 16:06'!
name: nameString emailAddress: emailString
    ^ self new
          name: nameString;
          emailAddress: emailString;
          yourself! !

!Contact class methodsFor: 'initialization' stamp: 'Evelyn 9/15/2012 16:07'!
removeContact: aContact
    self contacts remove: aContact! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:52'!
beFemale
    gender := #Female! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:52'!
beMale
    gender := #Male! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 17:35'!
birthdate
	    ^ birthdate! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 17:36'!
birthdate:  aDate
    birthdate := aDate! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:04'!
emailAddress
    ^ emailAddress! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:04'!
emailAddress: aString
    emailAddress := aString! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:51'!
gender
    ^ gender ifNil: [ gender := #Male ]! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:52'!
isFemale
    ^ self gender = #Female! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:52'!
isMale
    ^ self gender = #Male! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:04'!
name
    ^ name! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 16:05'!
name: aString
    name := aString! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 17:18'!
requestsEmailUpdates
    ^ requestsEmailUpdates ifNil: [ requestsEmailUpdates := false ]! !

!Contact methodsFor: 'as yet unclassified' stamp: 'Evelyn 9/15/2012 17:19'!
requestsEmailUpdates: aBoolean
    requestsEmailUpdates := aBoolean! !
